package Servlet;

import Datos.UsuarioDB;
import java.io.IOException;
import java.util.UUID;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpSession;
import Modelo.Usuario;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.codec.digest.DigestUtils;

public class RegistroServlet extends HttpServlet {

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String encoding = request.getCharacterEncoding();
        if (encoding == null) {
            request.setCharacterEncoding("UTF-8");
        }
        

        StringBuffer url_request = request.getRequestURL();
        String contraseña = request.getParameter("password");
        String contraseña2 = request.getParameter("password2");
        String correo = request.getParameter("correo");
        String nombre = request.getParameter("nombre");
        String apellidos = request.getParameter("apellidos");
        String tipo_usuario = request.getParameter("tipo_usuario");
        String url;
        HttpSession sesion = request.getSession();
        if (contraseña.equals(contraseña2)) {
            Usuario usuarioP = UsuarioDB.getUsuario(correo);
            if(usuarioP.getId_usuario().equals("")){
                String id_usuario = UUID.randomUUID().toString();
                if (tipo_usuario.equals("A")){
                    contraseña = DigestUtils.md5Hex(contraseña);
                    Usuario usuario = new Usuario(id_usuario,correo,contraseña,nombre,apellidos,tipo_usuario);
                    sesion.setAttribute("usuario", usuario);
                    url = "/registro2.jsp";
                }else {
                    contraseña = DigestUtils.md5Hex(contraseña);
                    Usuario usuario = new Usuario(id_usuario,correo,contraseña,nombre,apellidos,tipo_usuario);
                    if (UsuarioDB.addUsuario(usuario, contraseña)) {
                        sesion.setAttribute("usuario", usuario);
                        url = "/principal";
                    } else {
                        url = "/registro.jsp";
                        sesion.setAttribute("message", "Ocurrio un error en la creación del usuario.");
                    }
                }
            }else{
                sesion.setAttribute("message", "El correo ya existe.");
            url = "/registro.jsp";
            }
        } else {
            sesion.setAttribute("message", "Las contraseñas no coinciden.");
            url = "/registro.jsp";
        }
        RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(url);
        dispatcher.forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }
}
